#ifndef __CTRLENAB_H
#define __CTRLENAB_H

// This is the class declaration for TControlEnabler.  You derive your own custom
// enablers from it by overriding condition() to return TRUE for cases when the
// control supplied to the ctor should be enabled.  You can use getDialog() to get
// a pointer to the TCEDialog so you can query the states of the other controls or
// use TYPESAFE_DOWNCAST to get at your TCEDialog-derived class's data.

class TCEDialog;

class TControlEnabler
{
	public:
		friend class TCEDialog;

		TControlEnabler(int ctrlId)
			: id(ctrlId) {}
		virtual ~TControlEnabler() {}
		int operator==(const TControlEnabler& toCompare) const
		{
			return ((theDlg==toCompare.theDlg)&&(id==toCompare.id));
		}

	protected:
		virtual int condition() const { return 1; }
		int getId() const { return id; }
		const TCEDialog* getDialog() const { return theDlg; }

	private:
		void poll() const;
		int id;
		TCEDialog* theDlg;
};

#endif